IFDEF MM0
	mm0		TEXTEQU		MM0
	mm1		TEXTEQU		MM1
	mm2		TEXTEQU		MM2
	mm3		TEXTEQU		MM3
	mm4		TEXTEQU		MM4
	mm5		TEXTEQU		MM5
	mm6		TEXTEQU		MM6
	mm7		TEXTEQU		MM7
ENDIF

prold MACRO reg:REQ, dist:REQ
	movq  mm7, reg
	pslld reg, dist
	psrld mm7, (32-dist)
	por   reg, mm7
ENDM

prord MACRO reg:REQ, dist:REQ
	movq  mm7, reg
	psrld reg, dist
	pslld mm7, (32-dist)
	por   reg, mm7
ENDM

return MACRO ARG
	IFNB <ARG>
		IF (OPATTR (ARG)) AND 00000100y
			IF ARG EQ 0
				xor eax, eax
			ELSE
				mov eax, ARG
			ENDIF
		ELSEIFDIFI <eax>, <ARG>
			mov eax, ARG
		ENDIF
	ENDIF
	ret
ENDM

begtim MACRO
	rdtsc
	mov stim[4], edx
	mov stim[0], eax
ENDM

endtim MACRO
	rdtsc
	mov etim[4], edx
	mov etim[0], eax

	finit

	fild qword ptr etim
	fild qword ptr stim
	fsubp st(1), st(0)
	fistp ttim
ENDM

outhex MACRO arg:REQ
	pushad
	invoke dw2hex, arg, addr szBuff
	invoke StdOut, addr szBuff
	invoke StdOut, addr szRet
	popad
endm

prnterr MACRO pStr:REQ, Len:REQ
	invoke GetLastError
	mov edx, eax
	invoke FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM, NULL, edx, NULL, pStr, Len, NULL
	invoke StdOut, pStr
ENDM

















